Crowd_Funding_System/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('accounts/', include('apps.accounts.urls')),
    path('admin/', include('apps.admin_dashboard.urls')),
    path('projects/', include('apps.projects.urls')),
    path('categories/', include('apps.categories.urls')),
    path('', include('apps.homepage.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apps/homepage/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.home_page, name='home'),
    path('search/',  views.search, name="search"),
    path('api/projects/', views.get_projects_by_category_id, name='get_projects_by_category_id'),

]

apps/homepage/models.py
from django.db import models

# Create your models here.

apps/homepage/forms.py
from django import  forms

class SearchForm(forms.Form):
    options = [('project', 'Project'), ('tag', 'Tag')]
    search_option = forms.ChoiceField(choices=options)
    query = forms.CharField(max_length=100, label='', required=True)

    def clean_query(self):
        query = self.cleaned_data.get("query")
        if not query or query.isspace():
            raise forms.ValidationError("This field cannot be empty.")
        return query

apps/homepage/views.py
from django.shortcuts import render,get_object_or_404
from django.db.models import Avg, Count
from taggit.models import Tag
from .forms import SearchForm
from django.utils import timezone
from django.http import JsonResponse
from apps.projects.models import Project
from apps.categories.models import Category
from apps.accounts.models import CustomUser
# Create your views here.

def home_page(request):
    top_projects = Project.objects.filter(status='active', end_time__gt=timezone.now()).order_by('-rate')[:5]
    categories = Category.objects.all()
    categories_projects=Project.objects.all()
    for project in categories_projects:
        percentage = project.current_fund * 100 / project.total_target
        project.percentage = "{:.3f}".format(percentage)

    latest_projects = Project.objects.filter(status='active').order_by('-start_time')[:5]
    for project in latest_projects:
        percentage = project.current_fund * 100 / project.total_target
        project.percentage = "{:.3f}".format(percentage)

    featured_projects = Project.objects.filter(featured=True,status='active').order_by('-featured_at')[:5]
    for project in featured_projects:
        percentage = project.current_fund * 100 / project.total_target
        project.percentage = "{:.3f}".format(percentage)

    return render(request, 'homepage/index.html',context = {'top_projects':top_projects,
                                                            'latest_projects': latest_projects,
                                                            'featured_projects':featured_projects,
                                                            'categories':categories,
                                                            'categories_projects':categories_projects,
                                                            })

def get_projects_by_category_id(request):
    category_id = request.GET.get('category_id')
    if category_id:
        projects = Project.objects.filter(category_id=category_id,status='active')
    else:
        projects = Project.objects.all()

    for project in projects:
        percentage = project.current_fund * 100 / project.total_target
        project.percentage = "{:.3f}".format(percentage)

    data = [{'id': project.id, 'title': project.title, 'details': project.details, 
             'picture_url': project.picture_url, 'current_fund': project.current_fund, 
             'total_target': project.total_target,'slug':project.slug, 'percentage': project.percentage} 
            for project in projects]

    return JsonResponse({'projects': data})
    
def search(request):
    form = SearchForm(request.GET)
    results = []

    if form.is_valid():
        search_option = form.cleaned_data['search_option']
        query = form.cleaned_data['query'].strip()  # Remove leading/trailing spaces

        if search_option == 'project':
            results = Project.objects.filter(title__icontains=query)
            print(results)
        elif search_option == 'tag':
            # Filter projects by tags
            results = Project.objects.filter(tags__name__icontains=query)
            print(results)
        else:
            results = []
    else:
        results = []

    return render(request, 'homepage/search_results.html', {'searchForm': form, 'searchResults': results})
 
    

apps/homepage/templates/homepage/search_results.html
{% extends 'layouts/base.html' %}
{% load static %}

{% block title %} Home {%endblock %}
{% block navbar %}

{% include 'layouts/navbar.html' %}

{% endblock%}
{% block content %}

{% block styles %}
<!-- <link rel="stylesheet" href="{% static 'accounts/css/signup.css' %}"> -->

<style>

.section{
    margin-top: 100px;
}
</style>
{% endblock %}
<!-- Start hero section -->
<section class="d-flex align-items-center justify-content-center hero-section-header-bg section" id="hero-section">
<div class="container">
    <div class="d-flex align-items-center justify-content-center flex-column g-3 ">
        <div class="rounded-5 border border-danger-subtle px-1 w-50 bg-white">
            <form method="GET" action="{% url 'search' %}" class="d-flex align-items-center position-relative  ">
                <!-- {{form}} -->
                <div class="m-1">
                    {{searchForm.search_option}}
                </div>
                <div class="m-1">
                    {{searchForm.query}}
                </div>
                <button class="btn btn-special rounded-5 px-4 py-2 position-absolute align-items-center m-1 end-0">
                    <i class="fa-solid fa-magnifying-glass"></i>
                </button>
            </form>
        </div>
        <h3 class="mt-4">Search Results</h3>
    </div>
</div>
</section>

<div class="container my-5">
    <div class="row mb-5 g-4">
        {% if searchResults %}
            {% for searchResult in searchResults %}
                <div class="item col-3">
                        <div class="card p-2 bg-light">
                            <img src="{{searchResult.picture_url}}" style=" height: 200px; width: 100%;" class="card-img-top"
                                alt="project">
                            <div class="card-body">
                                <h5 class="card-title">{{searchResult.title}}</h5>
                                <p class="card-text">{{searchResult.details}}</p>
                                <progress class="w-100" value="{{ searchResult.current_fund }}"
                                    max="{{ searchResult.total_target }}"></progress>
                                <div class="d-flex justify-content-between">
                                    <p>{{searchResult.current_fund }} / {{ searchResult.total_target}}</p>
                                    <p>{{searchResult.percentag}} %</p>
                                </div>
                                <a href="{% url 'project_details' searchResult.slug %}" class="btn mt-1 text-white " style="background-color:#3dd0d8">Show project</a>
                            </div>
                        </div>
                    </div>
            {% endfor %}
        {% else %}
            <h4 class="text-center ">No data available.</h4>
        {% endif %}
    </div>
</div>

<script>
    selectElem = document.querySelector('#id_search_option');
    selectElem.classList.add("form-select", "rounded-5","border","border-danger-subtle");

    searchInput = document.querySelector('#id_query');
    searchInput.classList.add("form-control", "bg-white","border-0","rounded-4","shadow-none","py-3","w-100");
    // searchInput.classList.add("form-control");
</script>
{% endblock %}